using System;
using System.Collections.Generic;

class Project
{
    static void Main()
    {
        int n = int.Parse(Console.ReadLine());
        List<string> grupa = new List<string>(n);
        List<int> broj = new List<int>(n);
        string[] s = Console.ReadLine().Split();
        int O = int.Parse(s[0]);
        int A = int.Parse(s[1]);
        int B = int.Parse(s[2]);
        int AB = int.Parse(s[3]);
        int[,] matrica = new int[n, 4];
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < 4; j++)
            {
                matrica[i, j] = 0;
            }
        }
        int[] ab = new int[4]; ab[0] = 0; ab[1] = 0; ab[2] = 0; ab[3] = 0;
        for (int i = 0; i < n; i++)
        {
            s = Console.ReadLine().Split();
            grupa.Add(s[0]);
            broj.Add(int.Parse(s[1]));
        }

        for (int i = 0; i < n; i++)
        {
            switch (grupa[i])
            {
                case "O": for (int j = 0; j < broj[i]; j++) { if (O > 0) { matrica[i, 0]++; O--; } else { Console.WriteLine("nemoguce"); return; } } break;
                case "A": for (int j = 0; j < broj[i]; j++) { if (A > 0) { matrica[i, 1]++; A--; } else if (O > 0) { matrica[i, 0]++; O--; } else { Console.WriteLine("nemoguce"); return; } } break;
                case "B": for (int j = 0; j < broj[i]; j++) { if (B > 0) { matrica[i, 2]++; B--; } else if (O > 0) { matrica[i, 0]++; O--; } else { Console.WriteLine("nemoguce"); return; } } break;
                case "AB": for (int j = 0; j < broj[i]; j++)
                    { if (AB > 0) { matrica[i, 3]++; AB--; }
                        else if (A == B && A > 0) { matrica[i, 1]++; A--; }
                        else if (A > B && A > 0) { matrica[i, 1]++; A--; }
                        else if (B > A && B > 0) { matrica[i, 2]++; B--; }
                        else if (O > 0) {matrica[i, 0]++; O--; }
                        else { Console.WriteLine("nemoguce"); return; } } break;
            }
        }

        Console.WriteLine("moguce");
        for (int i = 0; i < n; i++)
        {
            for(int j = 0; j < 4; j++)
            {
                Console.Write(matrica[i, j] + " ");
            }
            Console.WriteLine();
        }
    }
}